;;; -*- Mode: Lisp; Package: editor -*-

;;; texinfo-mode.l --- Texinfo Mode.
;;
;; Created: [2006/11/01]
;; Last updated: [2007/06/20]
;;

;;; Commentary:
;;
;; Texinfo ҏWp[hB
;;
;; ق́FInfo2
;;

;;; Change Log:
;;
;; 2007/06/20
;;
;;     * ݂ȂRɎg悤C BSD CZXKpB
;;
;;     * Info M & CBzzeύXB
;;
;;     *  Info t@C Info2 ŕ\邱ƂɑΉB
;;
;;       ftHg Info2 ŕ\悤ɂ܂B
;;       "*texinfo-info-view-command*" Őݒł܂B
;;
;;     * ̑AJĂȂȉ̕ύXB
;;
;;       EOR}ȟʂ\obt@̍A\EBhE
;;         tOA\\obt@̔\EBhEtOwł
;;         悤ύXB
;;
;;       E\\̂CB
;;
;;       E\\AKw\ @code{@@menu} ɈړR}h
;;         ǉB
;;
;;       EWvR}hCB
;;       ETexinfo R}h⊮̎dCB
;;       EL[oChƂ傱܂ύXB
;;       Ȇ܂ȏCB
;;
;; 2005/07/08
;;
;;     * m[hR}hsɈړ@\ǉB
;;
;;     * R}hi@end vR}hj̊JnƏIɈړ@\
;;       ǉB
;;
;;     * ݎQƂwm[hւWvł悤ύXB
;;
;;     * makeinfo Ŋet@C𐶐̃ftHgIvVwł
;;       悤ύXB
;;
;;     * \\A@menu ƃCfg悤CB
;;
;;     * \\A@menu ֈړR}hǉB
;;
;;     * \\A or Oy[Wֈړ (v, z) łȂƂA2 s
;;       Ɉړ悤ɕύXB
;;
;;     * }R}hǉB
;;     * ⊮R}hǉB
;;     * ̑܂ȏCB
;;
;; 2005/05/31
;;
;;     * @item \\̂CB
;;
;;     * @item \\ @multitable \悤ɁB
;;
;; 2005/05/30
;;
;;     * ֐ texifo-mode  editor pbP[WɂA֐Aϐ exportB
;;      ɔA@ς܂B
;;
;;     *  Info, DVI, HTML, PDF, eLXg{R}hǉB
;;       ɔAL[oChύXB
;;
;;     * \\̃EBhEύXB|Cgobt@ɂ
;;       ƂړA{ƃG[EBhEoĂ܂̂CB
;;
;;     * \\EBhEEBhEɂ̏ꏊֈړR
;;       }hǉB
;;
;;     * texinfo-jump sAWvłȂ̂CB
;;
;; 2005/05/27
;;
;;     * ύXƂɁB
;;

;;; License:
;;
;; Copyright (c) 2007, Masanori Miyajima. All rights reserved.
;;
;; Redistribution and use in source and binary forms, with or without
;; modification, are permitted provided that the following conditions
;; are met:
;;
;;     * Redistributions of source code must retain the above copyright
;;       notice, this list of conditions and the following disclaimer.
;;
;;     * Redistributions in binary form must reproduce the above copyright
;;       notice, this list of conditions and the following disclaimer in
;;       the documentation and/or other materials provided with the
;;       distribution.
;;
;;    * The names of itscontributors may be used to endorse or promote
;;      products derived from this software without specific prior written
;;      permission.
;;
;; THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
;; IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
;; THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
;; PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
;; CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
;; EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
;; PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
;; PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
;; LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
;; NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
;; SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
;;

;;; Code:

(provide "texinfo-mode")
(in-package "editor")

(export '(
          texinfo-mode
          )
        "editor"
        )


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Defvar

(defvar *texinfo-mode-hook* nil
    "Texinfo [htbNϐB"
    )

(defvar *texinfo-mode-map* nil
    "Texinfo [hL[}bvB"
    )

(defvar *texinfo-structure-mode-hook* nil
    "\\[htbNϐB"
    )

(defvar *texinfo-structure-mode-map* nil
    "\\[hL[}bvB"
    )

(defvar *texinfo-regexp-keyword-list*
    (compile-regexp-keyword-list
     '(
       ("^@\\(node\\|anchor\\)[ \t]+[^,\n]*" nil 2)
       ("^@\\(chapter\\|unnumbered\\|appendix\\|majorheading\\|chapheading\\)[ \t]+"            nil 16)
       ("^@\\(section\\|unnumberedsec\\|appendixsec\\|appendixsection\\|heading\\)[ \t]+"       nil 6)
       ("^@\\(subsection\\|unnumberedsubsec\\|appendixsubsec\\|subheading\\)[ \t]+"             nil 13)
       ("^@\\(subsubsection\\|unnumberedsubsubsec\\|appendixsubsubsec\\|subsubheading\\)[ \t]+" nil 3)
       ("@\\(c\\|comment\\)[ \t]+.*$" nil :comment)
       ("^@ignore"                    nil :comment)
       ("^@end ignore$"               nil :comment)
       ("@[@{}][^@{} \n]*"            nil (:color 0))
       ("@[a-zA-Z]*\\|{\\|}"          nil 0)
       )
     )
    "FtK\̃XgB"
    )

(defvar *texinfo-begin-completion-list*
    '(
      "cartouche" "copying"
      "display" "deffn" "defmac" "defspec" "defun" "defopt" "deftypefn" "deftypefun" "defvar" "defvr" "detailmenu" "documentdescription"
      "enumerate" "example"
      "flushleft" "flushright" "format"
      "ifinfo" "ifnotinfo" "ifnotplaintext" "ifnottex" "iftex" "ignore" "itemize"
      "lisp"
      "menu" "multitable"
      "quotation"
      "smalldisplay" "smallexample" "smallformat" "smalllisp"
      "table" "titlepage"
      "verbatim"
      )
    "@end vR}hXgB"
    )

(defvar *texinfo-completion-list*
    (append
     '(
       "-"
       "abbr" "acronym" "appendix" "appendixsec" "appendixsection" "appendixsubsec" "appendixsubsubsec" "author"
       "bullet" "bye"
       "c" "chapheading" "chapter" "cindex" "code" "columnfractions" "command" "comment" "contents" "copyright"
       "dfn" "dots"
       "end" "enddots" "exampleindent" "exdent"
       "file" "findex" "firstparagraphindent" "footnote" "footnotestyle"
       "heading" "headings" "headitem" "hyphenation"
       "image" "include" "inforef" "insertcopying" "item" "itemx"
       "kbd" "key" "kindex"
       "majorheading" "math" "minus"
       "node" "noindent"
       "option"
       "page" "paragraphindent" "point" "printindex" "pxref"
       "ref" "result"
       "samp" "section" "setchapternewpage" "setfilename" "settitle" "strong" "subheading" "subsection" "subsubheading" "subsubsection" "subtitle"
       "tab" "TeX" "tie" "title" "top"
       "unnumbered" "unnumberedsec" "unnumberedsubsec" "unnumberedsubsubsec"
       "var" "verb" "verbatiminclude" "vindex"
       "w"
       "xref"
       "asis" "cp" "distinct" "double" "doubleafter" "fn" "insert" "ky" "none" "odd" "on" "off" "pg" "separate" "single" "singleafter" "tp" "vr"
       )
     *texinfo-begin-completion-list*
     )
    "R}h⊮XgB"
    )

(defvar *texinfo-heading-level-1*
    (compile-regexp "^@\\(chapter\\|top\\|unnumbered\\|appendix\\|majorheading\\|chapheading\\)[ ]*\\(.*\\)$"
                    nil
                    )
    "ox 1 ̃R}hK\B"
    )

(defvar *texinfo-heading-level-2*
    (compile-regexp "^@\\(section\\|unnumberedsec\\|appendixsec\\|appendixsection\\|heading\\)[ ]*\\(.*\\)$"
                    nil
                    )
    "ox 2 ̃R}hK\B"
    )

(defvar *texinfo-heading-level-3*
    (compile-regexp "^@\\(subsection\\|unnumberedsubsec\\|appendixsubsec\\|subheading\\)[ ]*\\(.*\\)$"
                    nil
                    )
    "ox 3 ̃R}hK\B"
    )

(defvar *texinfo-heading-level-4*
    (compile-regexp "^@\\(subsubsection\\|unnumberedsubsubsec\\|appendixsubsubsec\\|subsubheading\\)[ ]*\\(.*\\)$"
                    nil
                    )
    "ox 4 ̃R}hK\B"
    )

(defvar *texinfo-makeinfo-command* "makeinfo"
    "makeinfo R}hB"
    )

(defvar *texinfo-makeinfo-option* nil
    "Info  makeinfo IvVB"
    )

(defvar *texinfo-info-view-command* 2
    "1 ̂Ƃ info.lA2 ̂Ƃ info2.l p Info t@C{B"
    )

(defvar *texinfo-makeinfo-html-option* "--html"
    "HTML  makeinfo IvVB"
    )

(defvar *texinfo-tex-command* "ptex -src-specials"
    "TeX ^CvZbgR}hB"
    )

(defvar *texinfo-texindex-command* "texindex"
    "texindex R}hB"
    )

(defvar *texinfo-dvi-view-command* "dviout -1"
    "DVI t@C{R}hB"
    )

(defvar *texinfo-dvi2pdf-command* "dvipdfmx"
    "DVI  PDF 𐶐R}hB"
    )

(defvar *texinfo-output-buffer* "*output*"
    "o͂\obt@B"
    )

(defvar *texinfo-output-window-height* -5
    "o͂\obt@̍B"
    )

(defvar *texinfo-output-buffer-flags* (+ *window-flag-ruler*
                                         *window-flag-half-width-space*
                                         )
    "o͂\obt@̔\tOB"
    )

(defvar *texinfo-jump-pos* nil
    "ԑȌꏊB"
    )

(defvar *texinfo-mode-syntax-table* nil
    "V^bNXe[uB"
    )
(unless *texinfo-mode-syntax-table*
    (setf *texinfo-mode-syntax-table* (make-syntax-table))
    (do ((x #x21 (1+ x)))((>= x #x7f))
        (let ((c (code-char x)))
            (unless (alphanumericp c)
                (set-syntax-punctuation *texinfo-mode-syntax-table* c)
                )
            )
        )
    (set-syntax-escape *texinfo-mode-syntax-table* #\@)
    (set-syntax-match *texinfo-mode-syntax-table* #\{ #\})
    )

(defvar *texinfo-structure-buffer* " *Texinfo-structure*"
    "\\obt@B"
    )

(defvar *texinfo-structure-org-buffer* nil
    "\\̃obt@B"
    )

(defvar *texinfo-structure-flags* (+ *window-flag-newline*
                                     *window-flag-full-width-space*
                                     *window-flag-vscroll-bar*
                                     *window-flag-half-width-space*
                                     )
    "\\obt@Ŕ\ɂtOB"
    )

(defvar *texinfo-structure-regexp*
    (compile-regexp "^@\\(chapter\\|unnumbered\\|appendix\\|majorheading\\|chapheading\\|section\\|unnumberedsec\\|appendixsec\\|appendixsection\\|heading\\|subsection\\|unnumberedsubsec\\|appendixsubsec\\|subheading\\|subsubsection\\|unnumberedsubsubsec\\|appendixsubsubsec\\|subsubheading\\|c\\|comment\\|include\\)[ \t]+.*$\\|^@\\(ignore\\|menu\\)$"
                    )
    "\\R}hK\B"
    )

(defvar *texinfo-structure-item-regexp*
    (compile-regexp
     "^@\\(itemize\\|end itemize\\|enumerate\\|end enumerate\\|end table\\|end ftable\\|end vtable\\|end multitable\\|itemx?\\|headitem\\)$\\|^@\\(table\\|ftable\\|vtable\\|multitable\\|itemx?\\|headitem\\)[ \t]+.*$")
    "item \\R}hK\B"
    )

(defvar *texinfo-structure-line* nil
    "obt@\\sXgB"
    )

;;; Defvar
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Defun

(defun texinfo-structure-goto ()
    "ݍs̏ꏊֈړ"
    (interactive)
    (unless (eobp)
        (let ((lnum (current-line-number)))
            (delete-buffer (selected-buffer))
            (delete-window)
            (goto-line (first (nth (- (list-length *texinfo-structure-line*) lnum)
                                   *texinfo-structure-line*)))
            (recenter 1))))

(defun texinfo-structure-view (&optional arg)
    "ݍs̏ꏊ{"
    (interactive)
    (when (and (not (eobp))
               (find-buffer *texinfo-structure-org-buffer*))
        (let ((lnum (current-line-number))
              (win (get-buffer-window (find-buffer *texinfo-structure-org-buffer*))))
            (if win
                    (set-window win)
                (progn
                    (if (= (count-windows nil) 2)
                            (progn
                                (other-window)
                                (set-buffer (find-buffer *texinfo-structure-org-buffer*)))
                        (progn
                            (split-window-vertically)
                            (set-buffer (find-buffer *texinfo-structure-org-buffer*))))))
            (goto-line (first (nth (- (list-length *texinfo-structure-line*) lnum)
                                   *texinfo-structure-line*)))
            (recenter 1)
            (unless arg
                (set-window (get-buffer-window (find-buffer *texinfo-structure-buffer*)))))))

(defun texinfo-structure-jump ()
    "EBhEɌݍs̏ꏊֈړ"
    (interactive)
    (texinfo-structure-view t))

(defun texinfo-structure-next-menu ()
    " @menu Ɉړ"
    (interactive)
    (scan-buffer "^[ ]*@menu$" :no-dup t :regexp t))

(defun texinfo-structure-previous-menu ()
    "O @menu Ɉړ"
    (interactive)
    (scan-buffer "^[ ]*@menu$" :reverse t :no-dup t :regexp t))

(defun texinfo-close-structure ()
    "\\obt@"
    (interactive)
    (delete-buffer (selected-buffer))
    (delete-window))

(defun texinfo-structure-up-menu()
    "1 Kw @menu Ɉړ"
    (interactive)
    (goto-bol)
    (case (- (point)
             (progn
                 (skip-chars-forward " ")
                 (point)))
        (0 (goto-char 0)
           (scan-buffer "^@menu" :regexp t))
        (-4 (scan-buffer "^@menu" :reverse t :regexp t))
        (-8 (scan-buffer "^ \\{4\\}@menu" :reverse t :regexp t))
        (-12 (scan-buffer "^ \\{8\\}@menu" :reverse t :regexp t))))

(defun texinfo-structure-next-page ()
    "y[W or 2 s"
    (interactive)
    (unless (next-page)
        (next-virtual-line 2)))

(defun texinfo-structure-previous-page ()
    "Oy[W or 2 s"
    (interactive)
    (unless (previous-page)
        (previous-virtual-line 2)))

(defun texinfo-do-completion ()
    "R}h⊮"
    (interactive)
    (let ((from (progn
                    (skip-syntax-spec-backward "w_")
                    (point)))
          (to (progn
                  (skip-syntax-spec-forward "w_")
                  (point))))
        (do-completion from to :list *texinfo-completion-list*)))

(defun texinfo-jump ()
    "Ώۃt@CAm[hֈړ"
    (interactive)
    (let ((current-pos (point))
          (bol (progn
                   (goto-bol)
                   (point)))
          goto)
        (goto-char current-pos)
        (cond ((scan-buffer "@\\(xref\\|ref\\|pxref\\){[ ]*\\([^,}]+\\)[ ]*[,}]"
                            :reverse t
                            :regexp t
                            :limit bol)
               (setf goto (match-string 2))
               (push (list (buffer-name (selected-buffer))
                           current-pos)
                     *texinfo-jump-pos*)
               (if (scan-buffer (concat "@node[ ]+" (regexp-quote goto) "[ ]*[,\n]")
                                :regexp t)
                       (recenter 1)
                   (if (scan-buffer (concat "@node[ ]+" (regexp-quote goto) "[ ]*[,\n]")
                                    :reverse t
                                    :regexp t)
                           (recenter 1)
                       (progn
                           (pop *texinfo-jump-pos*)
                           (goto-char current-pos)
                           (message "m[h܂ \"~A\"" goto)))))
              ((scan-buffer "^\\*[ ]+\\(.+\\)::" :reverse t :regexp t :limit bol)
               (setf goto (match-string 1))
               (push (list (buffer-name (selected-buffer))
                           current-pos)
                     *texinfo-jump-pos*)
               (if (scan-buffer (concat "^@node[ ]+" (regexp-quote goto) "[ ]*[,\n]")
                                :regexp t)
                       (recenter 1)
                   (progn
                       (pop *texinfo-jump-pos*)
                       (goto-char current-pos)
                       (message "m[h܂ \"~A\"" goto))))
              ((scan-buffer "^\\*[ ]+.+:[ ]*\\(.+\\)\\." :reverse t :regexp t :limit bol)
               (setf goto (match-string 1))
               (push (list (buffer-name (selected-buffer))
                           current-pos)
                     *texinfo-jump-pos*)
               (if (scan-buffer (concat "^@node[ ]+" (regexp-quote goto) "[ ]*[,\n]")
                                :regexp t)
                       (recenter 1)
                   (progn
                       (pop *texinfo-jump-pos*)
                       (goto-char current-pos)
                       (message "m[h܂ \"~A\"" goto))))
              ((scan-buffer "^@include \\(.*\\)$" :reverse t :regexp t :limit bol)
               (setf goto (match-string 1))
               (if (file-exist-p goto)
                       (progn
                           (goto-char current-pos)
                           (push (list (buffer-name (selected-buffer))
                                       current-pos)
                                 *texinfo-jump-pos*)
                           (find-file goto))
                   (progn
                       (goto-char current-pos)
                       (message "t@C܂ \"~A\"" goto))))
              (t (goto-char current-pos)))))

(defun texinfo-rejump ()
    "ԑOɖ߂"
    (interactive)
    (when *texinfo-jump-pos*
        (let* ((goto-list (pop *texinfo-jump-pos*))
               (buf (find-buffer (nth 0 goto-list)))
               (pos (nth 1 goto-list)))
            (when (and goto-list
                       buf)
                (set-buffer buf)
                (goto-char pos)))))

(defun texinfo-count-environment (pattern lim rev)
    "R}h̓q̐JEg"
    (let ((num 0))
        (save-excursion
            (while (scan-buffer pattern :no-dup t :reverse rev :regexp t :limit lim)
                (incf num)))
        num))

(defun texinfo-goto-matched-environment ()
    "ΉR}hɈړ"
    (interactive)
    (let ((pos (point))
          (lim (progn
                   (goto-eol)
                   (point)))
          beg-command
          end-command
          rev
          end
          num)
        (goto-bol)
        (if (scan-buffer "^@end \\([^ \n]+\\)" :regexp t :limit lim)
                (setf beg-command (compile-regexp (concat "^@" (match-string 1)) t)
                      end-command (compile-regexp (concat "^@end " (match-string 1)) t)
                      lim (progn
                              (goto-bol)
                              (point))
                      rev t)
            (if (scan-buffer "^@\\([^ \n]+\\)" :regexp t :limit lim)
                    (setf beg-command (compile-regexp (concat "^@" (match-string 1)) t)
                          end-command (compile-regexp (concat "^@end " (match-string 1)) t))))
        (if (member (match-string 1)
                    *texinfo-begin-completion-list*
                    :test #'string-equal)
                (if rev
                        (progn
                            (scan-buffer beg-command :reverse t :regexp t)
                            (setf end (point))
                            (while (/= (setf num (texinfo-count-environment end-command lim nil)) 0)
                                (dotimes (tmp num)
                                    (scan-buffer beg-command :no-dup t :reverse t :regexp t))
                                (setf num 0
                                      lim end
                                      end (point))))
                    (progn
                        (scan-buffer end-command :tail t :regexp t)
                        (setf end (point))
                        (while (/= (setf num (texinfo-count-environment beg-command lim t)) 0)
                            (dotimes (tmp num)
                                (scan-buffer end-command :tail t :regexp t))
                            (setf num 0
                                  lim end
                                  end (point)))))
            (goto-char pos))))

(defun texinfo-insert-brace ()
    "gʂ̑΂}"
    (interactive)
    (insert "{}")
    (forward-char -1))

(defun texinfo-previous-node ()
    "Õm[hֈړ"
    (interactive)
    (if (scan-buffer "^@node" :no-dup t :reverse t :regexp t)
            (recenter 1)))

(defun texinfo-next-node ()
    "̃m[hֈړ"
    (interactive)
    (if (scan-buffer "^@node" :no-dup t :regexp t)
            (recenter 1)))



(defun texinfo-insert-node-pointer ()
    "m[h|C^}"
    (interactive)
    (let (str)
        (save-excursion
            (scan-buffer "^@node[ \t]+\\([^,\n]+\\)" :reverse t :tail t :regexp t))
        (when (setf str (match-string 1))
            (insert str))))

(defun texinfo-insert-command (cmd)
    "R}h}"
    (insert cmd)
    (forward-char -1))

(defun texinfo-insert-begin-skeleton ()
    "@end vR}h̃XPg}"
    (interactive)
    (let ((ime (prog1
                       (get-ime-mode)
                   (toggle-ime nil)))
          (command (completing-read "Command: "
                                    *texinfo-begin-completion-list*
                                    :must-match t)))
        (insert "@"
                command
                "\n\n"
                "@end "
                command)
        (forward-line -1)
        (when (string-equal command "table")
            (delete-char -1)
            (insert " "))
        (toggle-ime ime)))

(defun texinfo-insert-modifier ()
    "R}h}fBt@CA"
    (interactive)
    (let ((ime (get-ime-mode))
          cmd)
        (toggle-ime nil)
        (setf cmd (case (read-char)
                      ((#\b) 'texinfo-insert-begin-skeleton)
                      ((#\B) #'(lambda ()
                                   (interactive)
                                   (insert "@bullet{}")))
                      ((#\c) #'(lambda ()
                                   (interactive)
                                   (texinfo-insert-command "@code{}")))
                      ((#\C) #'(lambda ()
                                   (interactive)
                                   (texinfo-insert-command "@command{}")))
                      ((#\d) #'(lambda ()
                                   (interactive)
                                   (texinfo-insert-command "@dfn{}")))
                      ((#\D) #'(lambda ()
                                   (interactive)
                                   (insert "@dots{}")))
                      ((#\e) #'(lambda ()
                                   (interactive)
                                   (texinfo-insert-command "@email{}")))
                      ((#\E) #'(lambda ()
                                   (interactive)
                                   (texinfo-insert-command "@emph{}")))
                      ((#\f) #'(lambda ()
                                   (interactive)
                                   (texinfo-insert-command "@file{}")))
                      ((#\F) #'(lambda ()
                                   (interactive)
                                   (texinfo-insert-command "@footnote{}")))
                      ((#\i) #'(lambda ()
                                   (interactive)
                                   (insert "@item")))
                      ((#\I) #'(lambda ()
                                   (interactive)
                                   (texinfo-insert-command "@image{}")))
                      ((#\k) #'(lambda ()
                                   (interactive)
                                   (texinfo-insert-command "@kbd{}")))
                      ((#\K) #'(lambda ()
                                   (interactive)
                                   (texinfo-insert-command "@key{}")))
                      ((#\m) #'(lambda ()
                                   (interactive)
                                   (insert "@minus{}")))
                      ((#\M) #'(lambda ()
                                   (interactive)
                                   (texinfo-insert-command "@math{}")))
                      ((#\n) #'(lambda ()
                                   (interactive)
                                   (insert "@node ")))
                      ((#\N) 'texinfo-insert-node-pointer)
                      ((#\o) #'(lambda ()
                                   (interactive)
                                   (texinfo-insert-command "@option{}")))
                      ((#\p) #'(lambda ()
                                   (interactive)
                                   (insert "@point{}")))
                      ((#\r) #'(lambda ()
                                   (interactive)
                                   (insert "@result{}")))
                      ((#\s) #'(lambda ()
                                   (interactive)
                                   (texinfo-insert-command "@samp{}")))
                      ((#\S) #'(lambda ()
                                   (interactive)
                                   (texinfo-insert-command "@strong{}")))
                      ((#\t) #'(lambda ()
                                   (interactive)
                                   (insert "@tab")))
                      ((#\T) #'(lambda ()
                                   (interactive)
                                   (insert "@TeX{}")))
                      ((#\u) #'(lambda ()
                                   (interactive)
                                   (texinfo-insert-command "@url{}")))
                      ((#\v) #'(lambda ()
                                   (interactive)
                                   (texinfo-insert-command "@var{}")))
                      ((#\V) #'(lambda ()
                                   (interactive)
                                   (texinfo-insert-command "@verb{}")))))
        (toggle-ime ime)
        (when cmd
            (call-interactively cmd))))

(defun texinfo-makeinfo (&optional (option *texinfo-makeinfo-option*))
    "makeinfo "
    (interactive (when *prefix-args*
                     (list (read-string "Option: "
                                        :default *texinfo-makeinfo-option*))))
    (long-operation
        (let ((file (get-buffer-file-name))
              (win (get-buffer-window (selected-buffer))))
            (with-output-to-temp-buffer (*texinfo-output-buffer* *texinfo-output-window-height* nil)
                (set-local-window-flags (selected-buffer)
                                        *texinfo-output-buffer-flags*
                                        nil)
                (execute-shell-command (concat *texinfo-makeinfo-command*
                                               " "
                                               option
                                               " "
                                               file)
                                       nil
                                       (selected-buffer)))
            (unless (first-error)
                (insert "makeinfo done...")
                (set-window win)))))

(defun texinfo-makeinfo-html (&optional (option *texinfo-makeinfo-html-option*))
    "makeinfo - html"
    (interactive (when *prefix-args*
                     (list (read-string "Option: "
                                        :default *texinfo-makeinfo-html-option*))))
    (texinfo-makeinfo option))

(defun texinfo-make-pdf (&optional option)
    "DVI  PDF "
    (interactive (when *prefix-args*
                     (list (read-string "Option: "))))
    (let ((file (save-excursion
                    (goto-char (point-min))
                    (scan-buffer "^@setfilename[ ]+\\([^. ]+\\)" :regexp t)
                    (concat (match-string 1)
                            ".dvi"))))
        (when (file-exist-p file)
            (if option
                    (call-process (concat *texinfo-dvi2pdf-command*
                                          " "
                                          option
                                          " "
                                          file)
                                  :show :hide
                                  :wait t)
                (call-process (concat *texinfo-dvi2pdf-command*
                                      " "
                                      file)
                              :show :hide
                              :wait t)))))

(defun texinfo-makeinfo-text (&optional (option " --plaintext "))
    "makeinfo - text"
    (interactive (when *prefix-args*
                     (list (concat " --plaintext "
                                   (read-string "Option: ")))))
    (let ((file (get-buffer-file-name)))
        (execute-shell-command (concat *texinfo-makeinfo-command*
                                       option
                                       file
                                       " > "
                                       (pathname-name file)
                                       ".txt"))))

(defun texinfo-structure-mode ()
    "texinfo-structure-mode"
    (setf *texinfo-structure-org-buffer* (buffer-name (selected-buffer)))
    (split-window-vertically)
    (set-buffer (get-buffer-create *texinfo-structure-buffer*))
    (setf *texinfo-structure-buffer* (buffer-name (selected-buffer)))
    (kill-all-local-variables)
    (unless (= (point-max) (point-min))
        (erase-buffer (selected-buffer)))
    (setf mode-name "Texinfo-structure")
    (setf buffer-mode 'texinfo-structure-mode)
    (use-keymap *texinfo-structure-mode-map*)
    (make-local-variable 'regexp-keyword-list)
    (setf regexp-keyword-list *texinfo-regexp-keyword-list*)
    (make-local-variable 'mode-line-format)
    (setf mode-line-format (concat *texinfo-structure-org-buffer* " (%M)"))
    (make-local-variable 'kept-undo-information)
    (setf kept-undo-information nil)
    (make-local-variable 'need-not-save)
    (setf need-not-save t)
    (make-local-variable 'auto-save)
    (setf auto-save nil)
    (set-buffer-fold-type-none)
    (set-local-window-flags (selected-buffer)
                            *texinfo-structure-flags*
                            nil)
    (toggle-ime nil)
    (setf *texinfo-structure-line* nil)
    (run-hooks '*texinfo-structure-mode-hook*))

(defun texinfo-show-structure ()
    "\
Jgobt@̍\\B
"
    (interactive)
    (let (
          (buf (selected-buffer))
          str
          (clnum (current-line-number))
          (lnum 0)
          (col 0)
          )
        (toggle-ime nil)
        (if (and (find-buffer *texinfo-structure-buffer*)
                 (string-equal (buffer-name (selected-buffer)) *texinfo-structure-org-buffer*)
                 (get-buffer-window (find-buffer *texinfo-structure-buffer*))
                 )
                (set-window (get-buffer-window (find-buffer *texinfo-structure-buffer*)))
            (progn
                (texinfo-structure-mode)
                (setf buffer-read-only nil)
                (set-buffer buf)
                (save-excursion
                    (goto-char (point-min))
                    (while (scan-buffer *texinfo-structure-regexp*
                                        :tail t
                                        :regexp t)
                        (setf str (match-string 0))
                        (push (list (current-line-number))
                              *texinfo-structure-line*)
                        (when (>= clnum (current-line-number))
                            (incf lnum))
                        (set-buffer (find-buffer *texinfo-structure-buffer*))
                        (if (string-match *texinfo-heading-level-1* str)
                                (setf col 0)
                            (if (string-match *texinfo-heading-level-2* str)
                                    (progn
                                        (setf col 4)
                                        (insert " " 4))
                                (if (string-match *texinfo-heading-level-3* str)
                                        (progn
                                            (setf col 8)
                                            (insert " " 8))
                                    (if (string-match *texinfo-heading-level-4* str)
                                            (progn
                                                (setf col 12)
                                                (insert " " 12))
                                        (when (string-match "^@menu$" str)
                                            (insert " " col)
                                            (setf col 0))))))
                        (insert str "\n")
                        (set-buffer buf)))
                (set-buffer (find-buffer *texinfo-structure-buffer*))
                (goto-line lnum)
                (unless (mark t)
                    (set-mark-command))
                (recenter 1)
                (set-buffer-modified-p nil)
                (setf buffer-read-only t)))))

(defun texinfo-show-structure-item ()
    "Jgobt@ item \\"
    (interactive)
    (let ((buf (selected-buffer))
          (str "")
          (col 0)
          (clnum (current-line-number))
          (lnum 0))
        (toggle-ime nil)
        (if (and (find-buffer *texinfo-structure-buffer*)
                 (string-equal (buffer-name (selected-buffer)) *texinfo-structure-org-buffer*)
                 (get-buffer-window (find-buffer *texinfo-structure-buffer*)))
                (set-window (get-buffer-window (find-buffer *texinfo-structure-buffer*)))
            (progn
                (texinfo-structure-mode)
                (setf buffer-read-only nil)
                (set-buffer buf)
                (save-excursion
                    (goto-char (point-min))
                    (while (scan-buffer *texinfo-structure-item-regexp*
                                        :tail t
                                        :regexp t)
                        (setf str (match-string 0))
                        (push (list (current-line-number))
                              *texinfo-structure-line*)
                        (when (>= clnum (current-line-number))
                            (incf lnum))
                        (set-buffer (find-buffer *texinfo-structure-buffer*))
                        (if (string-match "^@\\(itemize\\|enumerate\\|table\\|ftable\\|vtable\\|multitable\\)" str)
                                (progn
                                    (insert " " col)
                                    (insert str "\n")
                                    (setf col (+ col 4)))
                            (if (string-match "^@end " str)
                                    (progn
                                        (insert " " (setf col (if (>= col 4)
                                                                      (- col 4)
                                                                  0)))
                                        (insert str "\n"))
                                (progn
                                    (insert " " col)
                                    (insert str "\n"))))
                        (set-buffer buf)))
                (set-buffer (find-buffer *texinfo-structure-buffer*))
                (goto-line lnum)
                (unless (mark t)
                    (set-mark-command))
                (recenter 1)
                (set-buffer-modified-p nil)
                (setf buffer-read-only t)))))

(defun texinfo-texindex ()
    "texindex"
    (interactive)
    (let ((file (save-excursion
                    (goto-char (point-min))
                    (scan-buffer "^@setfilename[ ]+\\([^. ]+\\)" :regexp t)
                    (match-string 1)))
          (type-list (list ".fn" ".ky" ".pg" ".tp" ".vr"))
          files)
        (when file
            (save-excursion
                (goto-char (point-min))
                (while (scan-buffer "^@defcodeindex[ ]+\\(\\w\\w\\)" :tail t :regexp t)
                    (push (concat "."
                                  (match-string 1))
                          type-list)))
            (setf files (concat file ".cp"))
            (dolist (tmp type-list)
                (setf files
                      (concat files
                              " "
                              (concat file tmp))))
            (call-process (concat *texinfo-texindex-command*
                                  " "
                                  files)
                          :show :hide
                          :wait t)
            (message "texindex done..."))))

(defun texinfo-tex-typeset (&optional option)
    "TeX"
    (interactive (when *prefix-args*
                     (list (read-string "Option: "))))
    (long-operation
        (let ((file (get-buffer-file-name))
              lnum)
            (with-output-to-temp-buffer (*texinfo-output-buffer* *texinfo-output-window-height* nil)
                (set-local-window-flags (selected-buffer)
                                        *texinfo-output-buffer-flags*
                                        nil)
                (if option
                        (execute-shell-command (concat *texinfo-tex-command*
                                                       " "
                                                       option
                                                       " "
                                                       file)
                                               nil
                                               (selected-buffer))
                    (execute-shell-command (concat *texinfo-tex-command*
                                                   " "
                                                   file)
                                           nil
                                           (selected-buffer)))
                (if (re-search-forward "^? $" t)
                        (error "G[")
                    (goto-char (point-max)))
                (other-window -1)))))

(defun texinfo-view-dvi ()
    "DVI t@C{"
    (interactive)
    (let ((file (read-file-name "DVI File: "
                                :default (save-excursion
                                             (goto-char (point-min))
                                             (scan-buffer "^@setfilename[ ]+\\([^. ]+\\)" :regexp t)
                                             (concat "./"
                                                     (match-string 1)
                                                     ".dvi")))))
        (if (file-exist-p file)
                (call-process (concat *texinfo-dvi-view-command*
                                      " "
                                      file)
                              :show :maximize)
            (message "t@C܂ ~A" file))))

(defun texinfo-view-html ()
    "HTML t@C{"
    (interactive)
    (let ((file (read-file-name "HTML: "
                                :default (save-excursion
                                             (goto-char (point-min))
                                             (scan-buffer "^@setfilename[ ]+\\([^. ]+\\)" :regexp t)
                                             (if (file-directory-p (match-string 1))
                                                     (concat "./"
                                                             (match-string 1)
                                                             "/index.html")
                                                 (concat "./"
                                                         (match-string 1)
                                                         ".html"))))))
        (if (file-exist-p file)
                (shell-execute file nil)
            (message "t@C܂ ~A" file))))

(defun texinfo-view-info ()
    "Info t@C{"
    (interactive)
    (let ((file (read-file-name "Info File: "
                                :default (save-excursion
                                             (goto-char (point-min))
                                             (scan-buffer "^@setfilename[ ]+\\(.+\\)$" :regexp t)
                                             (concat "./"
                                                     (match-string 1))))))
        (if (file-exist-p file)
                (case *texinfo-info-view-command*
                    ;; info.l
                    (
                     1
                     (require "info")
                     (info file)
                     )
                    ;; info2.l
                    (
                     2
                     (require "info2")
                     (info2 file)
                     )
                    )
            (message "t@C܂ ~A" file))))

(defun texinfo-view-pdf ()
    "PDF t@C{"
    (interactive)
    (let ((file (read-file-name "PDF: "
                                :default (save-excursion
                                             (goto-char (point-min))
                                             (scan-buffer "^@setfilename[ ]+\\([^. ]+\\)" :regexp t)
                                             (concat "./"
                                                     (match-string 1)
                                                     ".pdf")))))
        (if (file-exist-p file)
                (shell-execute file nil)
            (message "t@C܂ ~A" file))))

(defun texinfo-view-text ()
    "Text t@C{"
    (interactive)
    (let ((file (read-file-name "Text File: "
                                :default (save-excursion
                                             (goto-char (point-min))
                                             (scan-buffer "^@setfilename[ ]+\\([^. ]+\\)" :regexp t)
                                             (concat "./"
                                                     (match-string 1)
                                                     ".txt")))))
        (if (file-exist-p file)
                (find-file file)
            (message "t@C܂ ~A" file))))

(defun texinfo-mode ()
    "texinfo-mode"
    (interactive)
    (kill-all-local-variables)
    (setf mode-name "Texinfo")
    (setf buffer-mode 'texinfo-mode)
    (use-keymap *texinfo-mode-map*)
    (use-syntax-table *texinfo-mode-syntax-table*)
    (make-local-variable 'regexp-keyword-list)
    (setf regexp-keyword-list *texinfo-regexp-keyword-list*)
    (run-hooks '*texinfo-mode-hook*))

;;; Defun
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Keymap

;; Texinfo [hL[}bv
(unless *texinfo-mode-map*
    (setf *texinfo-mode-map* (make-sparse-keymap))
    ;; R}h⊮
    (define-key *texinfo-mode-map* #\TAB 'texinfo-do-completion)
    ;; Ώۃt@CAm[hֈړ
    (define-key *texinfo-mode-map* #\F9 'texinfo-jump)
    (define-key *texinfo-mode-map* #\S-F9 'texinfo-rejump)
    (define-key *texinfo-mode-map* #\C-] 'texinfo-goto-matched-environment)
    (define-key *texinfo-mode-map* #\{ 'texinfo-insert-brace)
    (define-key *texinfo-mode-map* #\C-{ 'texinfo-previous-node)
    (define-key *texinfo-mode-map* #\C-} 'texinfo-next-node)
    (define-key *texinfo-mode-map* '(#\C-c #\C-c) 'texinfo-insert-modifier)
    (define-key *texinfo-mode-map* '(#\C-c #\m #\i) 'texinfo-makeinfo)
    (define-key *texinfo-mode-map* '(#\C-c #\m #\h) 'texinfo-makeinfo-html)
    (define-key *texinfo-mode-map* '(#\C-c #\m #\p) 'texinfo-make-pdf)
    (define-key *texinfo-mode-map* '(#\C-c #\m #\t) 'texinfo-makeinfo-text)
    (define-key *texinfo-mode-map* '(#\C-c #\C-s) 'texinfo-show-structure)
    (define-key *texinfo-mode-map* '(#\C-c #\s) 'texinfo-show-structure-item)
    (define-key *texinfo-mode-map* '(#\C-c #\t #\i) 'texinfo-texindex)
    (define-key *texinfo-mode-map* '(#\C-c #\t #\t) 'texinfo-tex-typeset)
    (define-key *texinfo-mode-map* '(#\C-c #\v #\d) 'texinfo-view-dvi)
    (define-key *texinfo-mode-map* '(#\C-c #\v #\h) 'texinfo-view-html)
    (define-key *texinfo-mode-map* '(#\C-c #\v #\i) 'texinfo-view-info)
    (define-key *texinfo-mode-map* '(#\C-c #\v #\p) 'texinfo-view-pdf)
    (define-key *texinfo-mode-map* '(#\C-c #\v #\t) 'texinfo-view-text)
    )

;; \\[hL[}bv
(unless *texinfo-structure-mode-map*
    (setf *texinfo-structure-mode-map* (make-sparse-keymap))
    (define-key *texinfo-structure-mode-map* #\RET 'texinfo-structure-goto)
    (define-key *texinfo-structure-mode-map* #\TAB 'texinfo-structure-view)
    (define-key *texinfo-structure-mode-map* #\SPC 'texinfo-structure-jump)
    (define-key *texinfo-structure-mode-map* #\n 'next-virtual-line)
    (define-key *texinfo-structure-mode-map* #\N 'texinfo-structure-next-menu)
    (define-key *texinfo-structure-mode-map* #\p 'previous-virtual-line)
    (define-key *texinfo-structure-mode-map* #\P 'texinfo-structure-previous-menu)
    (define-key *texinfo-structure-mode-map* #\q 'texinfo-close-structure)
    (define-key *texinfo-structure-mode-map* #\u 'texinfo-structure-up-menu)
    (define-key *texinfo-structure-mode-map* #\v 'texinfo-structure-next-page)
    (define-key *texinfo-structure-mode-map* #\z 'texinfo-structure-previous-page)
    )

;;; Keymap
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;; texinfo-mode.l ends here
